%{
  module T = Tree.Tag
  let tag t d = Ast.Tagged (t, d)
%}

/* open tags */
%token OB OEM OI OPL OS OTT OU 
%token OS0 OS1 OS2 OS3 OS4 OS5 OS6 OS7 OS8 OS9 OCR OCG OCB OCC OCM OCY OCK OCW
/* close tags */
%token CB CEM CI CPL CS CTT CU 
%token CS0 CS1 CS2 CS3 CS4 CS5 CS6 CS7 CS8 CS9 CCR CCG CCB CCC CCM CCY CCK CCW

%token EOF
%token <string> TEXT 
%token <string> SPACE

%start document
%type <Ast.document> document

%% /* beginning of rules section */

document    : doc EOF           { $1 }

doc         : rdoc              { List.rev $1 }

rdoc        : rdoc element       { $2 :: $1}
            | /**/              { [] }

element     : TEXT          { Ast.Nonspace $1 }
            | SPACE         { Ast.Space  $1 }
            | OB   doc  CB  { Ast.Tagged (T.B, $2) }
            | OEM  doc  CEM { tag T.Em $2 }
            | OI   doc  CI  { tag T.I $2 }
            | OPL  doc  CPL { tag T.Pl $2 }
            | OS   doc  CS  { tag T.S $2 }
            | OTT  doc  CTT { tag T.Tt $2 }
            | OU   doc  CU  { tag T.U $2 }
            | OS0  doc  CS0 { tag (T.Size 0) $2 }
            | OS1  doc  CS1 { tag (T.Size 1) $2 }
            | OS2  doc  CS2 { tag (T.Size 2) $2 }
            | OS3  doc  CS3 { tag (T.Size 3) $2 }
            | OS4  doc  CS4 { tag (T.Size 4) $2 }
            | OS5  doc  CS5 { tag (T.Size 5) $2 }
            | OS6  doc  CS6 { tag (T.Size 6) $2 }
            | OS7  doc  CS7 { tag (T.Size 7) $2 }
            | OS8  doc  CS8 { tag (T.Size 8) $2 }
            | OS9  doc  CS9 { tag (T.Size 9) $2 }
            | OCR  doc  CCR { tag (T.Color Tree.Red) $2 }
            | OCG  doc  CCG { tag (T.Color Tree.Green) $2 }
            | OCB  doc  CCB { tag (T.Color Tree.Blue) $2 }
            | OCC  doc  CCC { tag (T.Color Tree.Cyan) $2 }
            | OCM  doc  CCM { tag (T.Color Tree.Magenta) $2 }
            | OCY  doc  CCY { tag (T.Color Tree.Yellow) $2 }
            | OCK  doc  CCK { tag (T.Color Tree.Black) $2 }
            | OCW  doc  CCW { tag (T.Color Tree.White) $2 }

%%

